package de.telefonbuch.model;

import org.jetbrains.annotations.NotNull;

import java.rmi.NotBoundException;
import java.rmi.RemoteException;

public class Datenbank {
	private final boolean CLIENT = true;
	private Sqlite sqlite;
	private Server server;
	private Client client;
	private final String IPADRESS = "127.0.0.1";

	public Datenbank() {

		if(CLIENT) {
			try {
				this.client = new Client(IPADRESS);
			} catch(RemoteException | NotBoundException e) {
				e.printStackTrace();
			}
		} else {
			this.sqlite = new Sqlite();
			// Neues Serverobjekt erstellen
			Server server = new Server(sqlite);
			server.start(server);
		}

		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);
	}

	public void addKontakt(@NotNull Kontakt kontakt) {
		if(CLIENT) {
			this.client.addKontakt(kontakt);
		} else {
			this.sqlite.addKontakt(kontakt);
		}
	}

	public void deleteKontakt(String telefon) {
		if(CLIENT) {
			this.client.deleteKontakt(telefon);
		} else {
			this.sqlite.deleteKontakt(telefon);
		}
	}

	public Kontakt getKontakt(@NotNull String telefon) {
		if(CLIENT) {
			return this.client.getKontakt(telefon);
		} else {
			return this.sqlite.getKontakt(telefon);
		}
	}

	public String[] getNavi(String telefon) {
		if(CLIENT) {
			return this.client.getNavi(telefon);
		} else {
			return this.sqlite.getNavi(telefon);
		}
	}

	public int countKontakte() {
		if(CLIENT) {
			return this.client.countKontakte();
		} else {
			return this.sqlite.countKontakte();
		}
	}
}
